#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

template<class T> T convert(string s) {
	stringstream ss(s);
	T t;
	ss >> t;
	return t;
}

struct Planet {
	string name;
	double diameter;

	Planet(string name, double diameter) {
		this->name = name;
		this->diameter = diameter;
	}

	string toString() {
		stringstream ss;
		ss << "Name: " << name << endl;
		ss << "Diameter: " << diameter << endl;

		return ss.str();
	}
};

void loadPlanets(ifstream& in, vector<Planet>& space) {
	string line;
	getline(in, line);

	while (getline(in, line)) {
		stringstream temp(line);

		string name;
		getline(temp, name, ',');

		string d;
		getline(temp, d);
		double diameter = convert<double>(d);

		Planet p(name, diameter);
		space.push_back(p);
	}

	in.close();
}

void printFirstThree(vector<Planet>& space) {
	partial_sort(space.begin(), space.begin() + 3, space.end(), [](Planet& l, Planet& r) {
		return l.diameter > r.diameter;
		});

	for (auto it = space.begin(); it != space.begin() + 3; ++it) {
		cout << it->toString() << endl;
	}
}

int main() {
	ifstream in("Solar_System_Reduced.csv");
	if (!in) {
		cout << "404" << endl;
		return 1;
	}

	vector<Planet> space;

	loadPlanets(in, space);

	printFirstThree(space);

	return 0;
}